function COVAIN_cluster(obj,evt)
%
%

h1 = get(obj,'Parent'); % hPanel_clusterTS
h2 = get(h1,'Parent');  % hPanel_dataAnalysis
h3 = get(h2,'Parent');  % hMain

dataStruct = guidata(h3);
if dataStruct.loadNumber == 0
    return;
end
currentData = dataStruct.dataset(dataStruct.current).dataInfo;
currentDataName = dataStruct.ID{dataStruct.current};

if currentData.dataTS_OK == 1  % if time series seq available
    nRow     = currentData.nRow;
    meanValue= currentData.dataTS;
    maxNumber = currentData.options.cluster;
    subInd = ceil(sqrt(maxNumber));
    times = 1:size(meanValue,2);
    subs = currentData.subs;
    scSize = get(0,'ScreenSize');
    switch get(findobj(h3,'Tag','radio_cluster_1'),'Value')
        case 1
            corrDist = pdist(meanValue, 'corr'); % 'euclidean'
            % corrDist = pdist(meanValue, 'euclidean');
            clusterTree = linkage(corrDist, 'average');
            clusters = cluster(clusterTree, 'maxclust', maxNumber);
            figure('Name',['Hierarchial clustering: ',currentDataName],...
                'NumberTitle','off','position',[50 100 0 0] + 0.7*scSize);
            for c = 1:maxNumber
                if c <= subInd*subInd
                    a = subplot(subInd,subInd,c);
                    % plot(times,meanValue((clusters == c),:)');
                    plot(times, detrend( meanValue((clusters == c),:)','constant'),'b' );
                    xlabel('Time series');
                    ylabel('Normalized concentration');
%                     fgSize = get(a,'position');
%                     ftSize = min(floor(.8*fgSize(4)*.7*scSize(4)/sum(clusters==c)) - 1,12);
%                     legend(subs(clusters == c),'Location','EastOutside',...
%                         'FontSize',ftSize);
                        %'position',[fgSize(1)+fgSize(3)+.05 fgSize(2) .2*fgSize(3) fgSize(4)] );
                end
            end
            suptitle('Hierarchical Clustering of Profiles');
        case 0
            [cidx, ctrs] = kmeans(meanValue, maxNumber,...
                'dist','sqEuclidean',...
                'rep',5,...
                'disp','off');
            figure('Name',['K-means clustering: ',currentDataName],...
                'NumberTitle','off','position',[50 100 0 0] + 0.7*get(0,'ScreenSize'));
            for c = 1:maxNumber
                if c <= subInd*subInd
                    a = subplot(subInd,subInd,c);
                    % plot(times,meanValue((cidx == c),:)');
                    plot(times, detrend( meanValue((cidx == c),:)','constant'),'b');
                    xlabel('Time series');
                    ylabel('Normalized concentration');
%                     fgSize = get(a,'position');
%                     ftSize = min(floor(.8*fgSize(4)*.7*scSize(4)/sum(cidx==c)) - 1,12);
%                     legend(subs(cidx == c),'Location','EastOutside',...
%                         'FontSize',ftSize);
                end
            end
            suptitle('K-Means Clustering of Profiles');
    end
    
else
    hWarn = warndlg('Please select time series!');
    uiwait(hWarn);
    uicontrol(findobj(h3,'Tag','edit_indexTS'));
end
