function COVAIN_clusterStatPop(obj,evt)

% firstly pop-up a new window, then select control and stress groups
% cluster the difference between stress and control

h = findobj('Tag','covainPanel_TOP');
dataStruct = guidata(h);
if dataStruct.loadNumber == 0
    return;
end
currentData = dataStruct.dataset(dataStruct.current).dataInfo;
cond = currentData.cond;

% pop-up the window
lenCond = length(cond);
lenStr = zeros(1,lenCond);
for i=1:lenCond
    lenStr(i) = length(cond{i});
end
lenStr = max(lenStr);

heiCell = 35;
widCell = max(lenStr,20)*10;

heiFig = heiCell*1.1*lenCond*1.4;
widFig = widCell*1.1*2.5;

heiCellX = heiCell/(heiFig*0.85);
widCellX = widCell/(widFig*0.4);
% [scrSize(3)-1.5*widFig scrSize(4)-1.5*heiFig widFig heiFig],...
scrSize  = get(0,'ScreenSize');
hClusterFig = figure('Position',[.5*widFig 50+0*heiFig widFig heiFig],...
    'Interruptible','on',...
    'Name','Cluster analysis',...
    'NextPlot','new',...
    'NumberTitle','off',...
    'Resize','on',...
    'MenuBar','none', ...
    'Toolbar','none', ...
    'Tag','clusterFig',...
    'HandleVisibility','callback');

hPanel_clusterFig = uipanel('Parent',hClusterFig,...
    'Title',[],...
    'Units','normalized',...
    'Position',[0 0 1 1],...
    'Tag','clusterFig_panel');

hButtonGroup_clusterFig = uibuttongroup('Parent',hPanel_clusterFig,...
    'Title','Choose the control sample',...
    'FontSize',11,...
    'FontWeight','bold',...
    'Units','normalized',...
    'Position',[.05 .15 .4 .75],...
    'Tag','clusterFig_Group1',...
    'SelectionChangeFcn',@COVAIN_treatSelect);
hPanelRight_clusterFig = uipanel('Parent',hPanel_clusterFig,...
    'Title','Choose treatment sample(s)',...
    'FontSize',11,...
    'FontWeight','bold',...
    'Units','normalized',...
    'Position',[.55 .15 .4 .75],...
    'Tag','clusterFig_Group2');
hButton_clusterFigView = uicontrol('Parent',hPanel_clusterFig,...
    'Style','pushbutton',...
    'String','View bicluster graph',...
    'FontSize',10,...
    'Units','normalized',...
    'Position',[.3 .02 .4 .11],...
    'Interruptible','off',...
    'Tag','clusterFig_view',...
    'CallBack',@COVAIN_clusterStat);

hRadio_clusterFig = zeros(1,lenCond);
for i=1:lenCond
    hRaio_clusterFig(i) = uicontrol('Parent',hButtonGroup_clusterFig,...
        'Style','radiobutton',...
        'String',cond{i},...
        'FontSize',9,...
        'Units','normalized',...
        'Position',[.05 (lenCond-i)*1.05*heiCellX widCellX heiCellX],...
        'Tag',['radio_clusterFig_cond',num2str(i)],...
        'Value',0);
end

hCheckBox_clusterFig = zeros(1,lenCond);
for i=1:lenCond
    hCheckBox_clusterFig(i) = uicontrol('Parent',hPanelRight_clusterFig,...
        'Style','checkbox',...
        'String',cond{i},...
        'FontSize',9,...
        'Units','normalized',...
        'Position',[.05 (lenCond-i)*1.05*heiCellX widCellX heiCellX],...
        'Tag',['checkbox_clusterFig_cond',num2str(i)],...
        'Value',1,...
        'CallBack',@COVAIN_treatSelect);
end
hCheckBoxAll_clusterFig = uicontrol('Parent',hPanelRight_clusterFig,...
    'Style','checkbox',...
    'String','Select all others',...
    'FontSize',9,...
    'Units','normalized',...
    'Position',[.05 1.05*lenCond*heiCellX widCellX heiCellX],...
    'Tag','checkboxAll_clusterFig_cond',...
    'Value',1,...
    'CallBack',@COVAIN_treatSelect);
% initialize
set(hCheckBox_clusterFig(1),'Value',0);
set(hCheckBox_clusterFig(1),'Enable','off');
