function COVAIN_combineData(obj,evt)
% 


% **********************************************
% hTop is handle of guidata
% open a new window to select datasets
% need to get the dataset list names
set(obj,'Userdata',0); 
hTop = get(obj,'Parent');
dataStruct = guidata(hTop);
if dataStruct.loadNumber <= 1
    return;
end

datasetID = dataStruct.ID; len0 = length(datasetID);
fig0 = figure('Position', [200 200 300 400],'Name','Choose datasets',...
              'Resize','on','Nextplot','new','Menubar','none','Toolbar',...
              'none','Tag','fig0','NumberTitle','off');
pan0 = uipanel('Parent',fig0,'Title',' Choose from the list ',...
               'FontSize',12,'Tag','pan0','Units','normalized',...
               'Position',[.05 .05 .9 .9]);
OK0 = uicontrol('Parent',pan0,'Style','pushbutton','String','OK','FontSize',...
                 11,'Units','normalized','Position',[.4 .05 .2 .1],...
                'Tag','OK0','Callback',@buttonOK0);
list0 = zeros(len0,1); hei = .8/(len0+1);
for i=1:len0
    list0(i) = uicontrol('Parent',pan0,'Style','checkbox','Value',0,...
                 'Max',1,'Min',0,'Units','normalized',...
                 'Position',[.05, 1-i*hei, .9, hei],'FontSize',11,...
                 'String',datasetID{i},'Tag',['list0_',num2str(i)]);
end
uiwait(fig0);
 
% **********************************************
% dataWhich is the index of selected dataset
% get information of each datasets including:
% nRep, nCond, ind1, count ... and save into a structure
dataWhich = get(obj,'Userdata');
if dataWhich == 0
    hw = warndlg('No data selected.');
    uiwait(hw); return;
end

colors = {'k','b','r','c','g','y'};
len = length(dataWhich);
colors = colors(1:len);
s.nRep = 0; s.nCond = 0; s.ind1 = 1; s.count = 0; 
s.condName = ''; s.dataName = ''; s.data = 0; 
s = repmat(s,len,1); % len*1 structure
for i=1:len
    s(i).nRep  = min(dataStruct.dataset(dataWhich(i)).dataInfo.count);
    s(i).nCond = length(dataStruct.dataset(dataWhich(i)).dataInfo.count);
    s(i).ind1  = dataStruct.dataset(dataWhich(i)).dataInfo.ind1;
    s(i).count = dataStruct.dataset(dataWhich(i)).dataInfo.count;
    s(i).data  = dataStruct.dataset(dataWhich(i)).dataInfo.data;
    s(i).condName = dataStruct.dataset(dataWhich(i)).dataInfo.cond;
    s(i).subs  = dataStruct.dataset(dataWhich(i)).dataInfo.subs;
    dataName = dataStruct.ID{dataWhich(i)};
    s(i).dataName = dataName(findstr('--',dataName)+2:end);
    s(i).dataSeq  = dataWhich(i);
end  

% **********************************************
% step 0: GUI layout
% size of up/down panels: 3/7 of 10
% width is fixed and can hold 5 conditions
% height is a function of number of conditions
% use different colors for different datasets
min_nCond = min(arrayfun(@(x) x.nCond,s));
min_nRep  = min(arrayfun(@(x) x.nRep,s));
nRow_fig  = ceil(min_nCond/5); nRowRes = 5 - 5*nRow_fig + min_nCond;
hText1 = zeros(len,1); hText2 = zeros(len,1); hEdit = zeros(len,1);
hText3 = zeros(len,nRow_fig); hCond = zeros(len,min_nCond); ctx = 0;
figLoc = [75 75 900 500+100*nRow_fig];
fig     = figure('Position',figLoc,'Name','Combine data','Resize','on',...
                 'Nextplot','new','Menubar','none','Toolbar','none',...
                 'Tag','figCombine','NumberTitle','off');
panRep  = uipanel('Parent',fig','Title',' Select replicates ',...
                 'FontSize',12,'Tag','panRep','Units','normalized',...
                 'Position',[.01 .7 .98 .28]);
panCond = uipanel('Parent',fig','Title',' Select conditions ',...
                 'FontSize',12,'Tag','panCond','Units','normalized',...
                 'Position',[.01 .01 .98 .65]);
hOK1 = uicontrol('Parent',panRep,'Units','normalized','String','OK',...
                 'Position',[.8 .1 .1 .15],'FontSize',11,...
                 'Tag','OK1','Callback',@buttonOK1,...
                 'Userdata',repmat(1:min_nRep,len,1));
hOK2 = uicontrol('Parent',panCond,'Units','normalized','String','OK',...
                 'Position',[.8 .1 .1 .07],'FontSize',11,...
                 'Tag','OK2','Callback',@buttonOK2);             
for i=1:len
    hText1(i) = uicontrol('Parent',panRep,'Style','text',...
                  'String',s(i).dataName,'FontSize',11,...
                  'ForegroundColor',colors{i},'Units','normalized',...
                  'Position',[.02 1-0.15*i .2 .12],...
                  'Tag',['text1_',num2str(i)],'Max',1,'Min',0);
    hText2(i) = uicontrol('Parent',panRep,'Style','text',...
                  'String',[' contains ',num2str(s(i).nRep),' replicates. Please input indices of replicates: '],...
                  'FontSize',11,'ForegroundColor',colors{i},...
                  'Units','normalized','Position',[.25 1-0.15*i .45 .12],...
                  'Tag',['text2_',num2str(i)],'Max',1,'Min',0);
    hEdit(i)  = uicontrol('Parent',panRep,'Style','edit',...
                  'String',num2str(1:min_nRep),'FontSize',11,...
                  'ForegroundColor',colors{i},'Units','normalized',...
                  'Position',[.75 1-0.15*i .23 .12],...
                  'Tag',['edit_',num2str(i)],'Max',1,'Min',0);
    for j=1:nRow_fig
        hText3(i,j) = uicontrol('Parent',panCond,'Style','text',...
                'String',s(i).dataName,'FontSize',11,...
                'ForegroundColor',colors{i},'Units','normalized',...
                'Position',[.02, 1-(j-1)*1/nRow_fig-0.1*i, .2, .06],...
                'Tag',['text3_',num2str((j-1)*len+i)],'Max',1,'Min',0); 
        if j == nRow_fig
            kEnd = nRowRes;
        else
            kEnd = 5;
        end
        ctx = ctx + 1;
        for k=1:kEnd
            hCond(i,(j-1)*5+k) = uicontrol('Parent',panCond,'Style','popupmenu',...
                 'String',s(i).condName,'Value',(j-1)*5+k,'Units','normalized',...
                 'Position',[0.25+0.15*(k-1), 1-(j-1)*1/nRow_fig-0.1*i, .1 .06],...
                 'FontSize',11,'Tag',['cond_',num2str(ctx)]);
        end
    end
end
    
% **********************************************
% step 0: select datasets
    function buttonOK0(objS,evtS)
        values = zeros(len0,1);
        for m = 1:len0
            values(m) = get(list0(m),'Value');
        end
        if sum(values) <= 1
            hWarn_values =  warndlg('At least two datasets need to be selcted!');
            uiwait(hWarn_values);
            uicontrol(objS);
            %delete(fig0);
        else
            set(obj,'UserData',find(values==1));
            delete(fig0);
        end
    end

% **********************************************
% step 1: replicates selection
    function buttonOK1(objS,evtS)
        % get input and check their validity
        input = cell(len,1);
        inputLen = zeros(len,1);
        for iL = 1:len
            input{iL} = get(hEdit(iL),'String');
            inputLen(iL) = length(str2num(input{iL}));
        end
        if min(inputLen) == 0 || max(inputLen) > min_nRep
            hWarn_inputLen = warndlg('Input exceeds index boundary!');
            uiwait(hWarn_inputLen);
        elseif length(unique(inputLen)) > 1
            hWarn_inputSize = warndlg('Input sizes are different!');
            uiwait(hWarn_inputSize);
        else
            idxOut = zeros(len,inputLen(1));
            for iL = 1:len
                idxOut(iL,:) = str2num(input{iL});
            end
            set(objS,'Userdata',idxOut); % update OK1 button userdata
            set(objS,'BackgroundColor',[1 0 1]);
        end
    end       

% **********************************************
% step 2: conditions selection
    function buttonOK2(objS,evtS)
        % collect other data
        idxRep = get(hOK1,'Userdata');
        % get input 
        idxCond = zeros(len,min_nCond);
        for iL = 1:len
            for iC = 1:min_nCond
                idxCond(iL,iC) = get(hCond(iL,iC),'Value');
            end
        end
        % check input's validity
        flgWarn = 0;
        for iL = 1:len
            if length(unique(idxCond(iL,:))) < min_nCond
                hWarn_idxCond = warndlg('Repeated selection!');
                uiwait(hWarn_idxCond);
                flgWarn = 1;
            end
        end
        % then combine the data
        if flgWarn == 0 % the condition selection is correct
            for m = 1:len
                idxGlobal = zeros(1,min_nCond*min_nRep);
                for n = 1:min_nCond
                    idxBase  = s(m).ind1(idxCond(m,n));
                    idxAlias = idxRep(m,:) - 1;
                    idxLocal = idxBase + idxAlias;
                    idxGlobal((n-1)*min_nRep+1:(n-1)*min_nRep+min_nRep) = idxLocal;
                end
                if m == 1
                    dataNew = s(m).data(:,idxGlobal);
                else
                    dataNew = [dataNew; s(m).data(:,idxGlobal)];
                end
            end
            
            % add this dataNew as a new dataset
            % use dataSeq as name, not dataName, besause it may be too long
            
            condNameNew = cell(1,min_nCond);
            sampleNameNew = cell(1,min_nCond*min_nRep);
            for m = 1:min_nCond
                tempStr = cell(1,len);
                for n = 1:len
                    tempStr{n} = s(n).condName{idxCond(n,m)};
                end
                [tempUnique,tempIdx] = unique(tempStr);
                for n = 1:length(tempIdx)
                    condNameNew{m} = [condNameNew{m},tempStr{tempIdx(n)},'+'];
                end 
                condNameNew{m}(end) = [];
                for n = 1:min_nRep
                    sampleNameNew{(m-1)*min_nRep+n} = condNameNew{m};
                end
            end
            
            % need to change repeated names
            subsNameNew = s(1).subs; 
            for m = 2:len
                subsNameCurrent = s(m).subs;
                [waste,idxA] = intersect(subsNameCurrent,subsNameNew);
                if isempty(waste)
                    subsNameNew = [subsNameNew;subsNameCurrent];
                else
                    for n = 1:length(waste)
                        subsNameCurrent{idxA(n)} = ['Data',num2str(m),' - ',subsNameCurrent{idxA(n)}];
                    end
                    subsNameNew = [subsNameNew;subsNameCurrent];
                end
            end
            
            dataNameNew = 'Combined-';
            for m = 1:len
                dataNameNew = [dataNameNew,num2str(s(m).dataSeq),'-'];
            end
            dataNameNew(end) = [];
            
            dataRaw = cell(size(dataNew)+1);
            dataRaw(1,2:end) = sampleNameNew;
            dataRaw(2:size(dataRaw,1)) = subsNameNew;
            dataRaw(2:end,2:end) = num2cell(dataNew);
            dataRaw{1} = 'CPD';
                
            % OK, update the guidata
            try
                COVAIN_loadIntData(dataRaw,dataNameNew,hTop);
                delete(fig);
            catch err
                hWarn_CombineText = err.message;
                hWarn_Combine = warndlg(hWarn_CombineText);
                uiwait(hWarn_Combine);
            end

        end
    end % nested function end


% ******************************************
end % main function

