function COVAIN_corrStat(obj,evt)
%
%

h = findobj('Tag','covainPanel_TOP');
dataStruct = guidata(h);
if dataStruct.loadNumber == 0
    return;
end
currentDataName = dataStruct.ID{dataStruct.current};
currentData = dataStruct.dataset(dataStruct.current).dataInfo;
corrMethod = currentData.options.corr;

if currentData.dataStat_OK == 1  %
    nameSub  = currentData.subs;
    nRow     = currentData.nRow;
    % meanValue= currentData.table;
    meanValue= currentData.dataStat;
    nCol = size(meanValue,2);
    data = currentData.data;  % all data !!
    cond = currentData.condStat;
    path1 = currentData.savePath;
    
    if nRow >= 40
        ftSize = ceil(320/nRow);
    else
        ftSize = 8;
    end
    
    if nRow >= 20000
        answer = questdlg('Only the Pearson correlation coefficients will be calaculted.',...
            'Large dataset','Proceed with external MEX','Quit','Quit');
        if strcmp(answer,'Proceed with external MEX')==1
            corrStat = pearsonMEX(meanValue',0,nRow); 
            % if out of memory problem, split nrow, calculate and write to file sequencially. see below.
            dlmwrite([path1,'corrcoef_Stat.txt'],corrStat,'delimiter','\t','newline','pc');
        end
        % =======  some example codes for very large datasets: =========
%         ncols = 20000; % 20k variables, a large dataset
%         nblocks = 5000; % every round calculate 5000 variables
%         data = rand(20,ncols); % a random dataset, 20 observations
%         nLoop = ceil(ncols/nblocks);
%         for k=1:nLoop
%             if k == 1
%                 c = pearsonMEX(data,(k-1)*nblocks,k*nblocks);
%                 dlmwrite([path1,'corrcoef.txt'],c,'delimiter','\t','newline','pc');
%                 clear c;
%             elseif k ~= nLoop
%                 c = pearsonMEX(data,(k-1)*nblocks,k*nblocks);
%                 dlmwrite([path1,'corrcoef.txt'],c,'-append','delimiter','\t','newline','pc');
%                 clear c;
%             else
%                 c = pearsonMEX(data,(k-1)*nblocks,ncols);
%                 dlmwrite([path1,'corrcoef.txt'],c,'-append','delimiter','\t','newline','pc');
%                 clear c;
%             end
%         end
        % ========== example ends ====================================
        
        
    elseif strcmp(get(obj,'Tag'),'button_doCorr') == 1 % correlation
        if strcmp(corrMethod,'Pearson')==1
            if length(cond) == 2
                [corrStat,pval] = corr(data');
            else
                [corrStat,pval] = corr(meanValue');
                %[corrStat,pval] = corr(data');
            end
        else
            if length(cond) == 2
                [corrStat,pval] = corr(data','Type','Spearman');
            else
                [corrStat,pval] = corr(meanValue','Type','Spearman');
            end
        end
        % put pval_diag = 1
        pval(1+ (1+nRow)*((1:nRow)-1)) = 1; % (diag_loc in i-th row = 1+(N+1)*(i-1))
 
        figure('Name',['Correlation: ',currentDataName],'NumberTitle','off');
        imagesc(corrStat);colorbar;
        set(gca,'XTick',1:nRow,'XTickLabel',[]);
        set(gca,'YTick',1:nRow,'YTickLabel',nameSub');
        set(gca,'FontSize',ftSize);
        
        xTick = get(gca,'XTick');
        yTick = get(gca,'YTick');
        text(xTick,repmat(yTick(end)+.9,length(xTick),1),nameSub,...
            'HorizontalAlignment','right','rotation',30,'FontSize',ftSize+1,'FontName','Arial');
        
        % ylabel('Substances','FontSize',12);
 
        currentData.corrStat = corrStat;
        currentData.corrStat_pval = pval;
        currentData.corrStat_OK = 1;
        
        % update guidata
        dataStruct.dataset(dataStruct.current).dataInfo = currentData;
        guidata(h,dataStruct);
        
        
    else % heatmap
        figure('Name',['Heatmap: ',currentDataName],'NumberTitle','off');
        imagesc(meanValue); colorbar;
        set(gca,'XTick',1:nCol,'XTickLabel',[]);
        set(gca,'YTick',1:nRow,'YTickLabel',nameSub');
        set(gca,'FontSize',ftSize);
        
        xTick = get(gca,'XTick');
        yTick = get(gca,'YTick');
        text(xTick,repmat(yTick(end)+.9,length(xTick),1),cond,...
            'HorizontalAlignment','right','rotation',30,'FontSize',12,'FontName','Arial');

    end
   
else
    hWarn = warndlg('Please select the data!');
    uiwait(hWarn);
    uicontrol(findobj(h,'Tag','checkbox_Stat'));
end

