function corrTS = COVAIN_corrTS(obj,evt)
%
%

h = findobj('Tag','covainPanel_TOP');
dataStruct = guidata(h);
if dataStruct.loadNumber == 0
    return;
end
currentDataName = dataStruct.ID{dataStruct.current};
currentData = dataStruct.dataset(dataStruct.current).dataInfo;
corrMethod = currentData.options.corr;

if currentData.dataTS_OK == 1  % if time series seq available
    nameSub  = currentData.subs;
    nRow     = currentData.nRow;
    data = currentData.data;
    cond = currentData.condTS;
    meanValue = currentData.dataTS;
    nCol = size(meanValue,2);
    if nRow >= 40
        ftSize = 6;
    else
        ftSize = 8;
    end
    
    
    if nRow >= 1000
        answer = questdlg('Only the Pearson correlation coefficients will be calaculted.',...
            'Large dataset','Proceed with external MEX','Quit','Quit');
        if strcmp(answer,'Proceed with external MEX')==1
            corrTS = pearsonMEX(meanValue',0,nrow); 
            % if out of memory problem, split nrow, calculate and write to file sequencially. see below.
            dlmwrite([path1,'corrcoef_TS.txt'],corrTS,'delimiter','\t','newline','pc');
        end
        % =======  some example codes for very large datasets: =========
%         ncols = 20000; % 20k variables, a large dataset
%         nblocks = 5000; % every round calculate 5000 variables
%         data = rand(20,ncols); % a random dataset, 20 observations
%         nLoop = ceil(ncols/nblocks);
%         for k=1:nLoop
%             if k == 1
%                 c = pearsonMEX(data,(k-1)*nblocks,k*nblocks);
%                 dlmwrite([path1,'corrcoef.txt'],c,'delimiter','\t','newline','pc');
%                 clear c;
%             elseif k ~= nLoop
%                 c = pearsonMEX(data,(k-1)*nblocks,k*nblocks);
%                 dlmwrite([path1,'corrcoef.txt'],c,'-append','delimiter','\t','newline','pc');
%                 clear c;
%             else
%                 c = pearsonMEX(data,(k-1)*nblocks,ncols);
%                 dlmwrite([path1,'corrcoef.txt'],c,'-append','delimiter','\t','newline','pc');
%                 clear c;
%             end
%         end
        % ========== example ends ====================================
        
    elseif strcmp(get(obj,'Tag'),'button_corrTS') == 1 % correlation     
        if strcmp(corrMethod,'Pearson')==1
            if length(cond) == 2
                [corrTS,pval] = corr(data');
            else
                [corrTS,pval] = corr(meanValue');
            end
        else
            if length(cond) == 2
                [corrTS,pval] = corr(data','Type','Spearman');
            else
                [corrTS,pval] = corr(meanValue','Type','Spearman');
            end
        end
        % put pval_diag = 1
        pval(1+ (1+nRow)*((1:nRow)-1)) = 1; % (diag_loc in i-th row = 1+(N+1)*(i-1))
        
        figure('Name',['Correlation-Time Sereis: ',currentDataName],'NumberTitle','off');
        imagesc(corrTS);colorbar;
        set(gca,'XTick',1:nRow,'XTickLabel',[]);
        set(gca,'YTick',1:nRow,'YTickLabel',nameSub');
        set(gca,'FontSize',ftSize);
        
        xTick = get(gca,'XTick');
        yTick = get(gca,'YTick');
        text(xTick,repmat(yTick(end)+.9,length(xTick),1),nameSub,...
            'HorizontalAlignment','right','rotation',30,'FontSize',ftSize+1,'FontName','Arial');       
        % ylabel('Substances','FontSize',12);

        currentData.corrTS = corrTS;
        currentData.corrTS_pval = pval;
        currentData.corrTS_OK = 1;
        
        % update guidata
        dataStruct.dataset(dataStruct.current).dataInfo = currentData;
        guidata(h,dataStruct);
        
    else  % heatmap
        figure('Name',['Heatmap - Time Series: ',currentDataName],'NumberTitle','off');
        imagesc(meanValue); colorbar;
        set(gca,'XTick',1:nCol,'XTickLabel',[]);
        set(gca,'YTick',1:nRow,'YTickLabel',nameSub');
        set(gca,'FontSize',ftSize);
        
        xTick = get(gca,'XTick');
        yTick = get(gca,'YTick');
        text(xTick,repmat(yTick(end)+.9,length(xTick),1),cond,...
            'HorizontalAlignment','right','rotation',30,'FontSize',12,'FontName','Arial');
    end
        
else
    hWarn = warndlg('Please select time series!');
    uiwait(hWarn);
    uicontrol(findobj(h,'Tag','edit_indexTS'));
end
