function COVAIN_dataSelect(obj,evt)
%

h1 = get(obj,'Parent'); % hPanel_dataSelect
h2 = get(h1,'Parent'); % hPanel_dataInfo
hTop = get(h2,'Parent'); % hPanel_Main

dataStruct = guidata(hTop);
if dataStruct.loadNumber == 0
    return;
end
dataStruct.current = get(obj,'Value');

% update info on which data was selected
% only shows the first data if multiple items have been selected
guidata(hTop,dataStruct);
currentData = dataStruct.dataset(min(dataStruct.current)).dataInfo;
color_default = get(findobj(hTop,'Tag','button_load'),'BackgroundColor');
color_new = [1 0 1];

infoStr = currentData.textInfo;
infoStr = strcat('COVAIN assumes rows are substances and columns are samples. ',infoStr);
missStr = currentData.textMiss;
outStr  = currentData.textOut;


% update the data info
set(findobj(hTop,'Tag','text_info'),'String',infoStr,...
    'Enable','on');
set(findobj(hTop,'Tag','text_miss'),'String',missStr,...
    'Enable','on');
set(findobj(hTop,'Tag','text_outlier'),'String',outStr,...
    'Enable','on');
set(findobj(hTop,'Tag','checkbox_Stat'),'Value',0);
set(findobj(hTop,'Tag','checkbox_TS'),'Value',0);

% reset currentData status
currentData.dataTS_OK = 0;
currentData.dataStat_OK = 0;
dataStruct.dataset(min(dataStruct.current)).dataInfo = currentData;
guidata(hTop,dataStruct);

% update process history
if currentData.historyTrans == 1
    set(findobj(hTop,'Tag','button_trans'),'BackgroundColor',color_new);
else
    set(findobj(hTop,'Tag','button_trans'),'BackgroundColor',color_default);
end
if currentData.historyNorm == 1
    set(findobj(hTop,'Tag','button_norm'),'BackgroundColor',color_new);
else
    set(findobj(hTop,'Tag','button_norm'),'BackgroundColor',color_default);
end
if currentData.historyMiss == 1
    set(findobj(hTop,'Tag','button_miss'),'BackgroundColor',color_new);
else
    set(findobj(hTop,'Tag','button_miss'),'BackgroundColor',color_default);
end
if currentData.historyOut == 1
    set(findobj(hTop,'Tag','button_outlier'),'BackgroundColor',color_new);
else
    set(findobj(hTop,'Tag','button_outlier'),'BackgroundColor',color_default);
end
if currentData.historyLog == 1
    set(findobj(hTop,'Tag','button_log'),'BackgroundColor',color_new);
else
    set(findobj(hTop,'Tag','button_log'),'BackgroundColor',color_default);
end
if currentData.historyZc == 1
    set(findobj(hTop,'Tag','button_Ztrans'),'BackgroundColor',color_new);
else
    set(findobj(hTop,'Tag','button_Ztrans'),'BackgroundColor',color_default);
end
if currentData.historyZr == 1
    set(findobj(hTop,'Tag','button_ZtransR'),'BackgroundColor',color_new);
else
    set(findobj(hTop,'Tag','button_ZtransR'),'BackgroundColor',color_default);
end

% get(findobj(hTop,'Tag','popup_norm'),'String')
% if currentData.historyFW == 1
%     set(findobj(hTop,'Tag','popup_norm'),'Value',3);
%     set(findobj(hTop,'Tag','popup_norm'),'ForegroundColor',color_new);
% elseif currentData.historyIS == 1
%     set(findobj(hTop,'Tag','popup_norm'),'Value',2);
%     set(findobj(hTop,'Tag','popup_norm'),'ForegroundColor',color_new);
% else    
%     set(findobj(hTop,'Tag','popup_norm'),'Value',3,'ForegroundColor',color_default);
%     % set(findobj(hTop,'Tag','popup_norm'),'ForegroundColor',color_default);
% end
% get(findobj(hTop,'Tag','popup_norm'),'Value')

% update table preview, show mean value only!
currentTable = currentData.table;
currentTableColName = currentData.cond;
currentTableRowName = currentData.subs;
set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
    'ColumnName',currentTableColName,'RowName',currentTableRowName,...
    'Enable','on');
set(findobj(hTop,'Tag','radio_tableSelect_2'),'Value',1);

% if currentData.whichTable == 1
%     currentTable = currentData.sample;
%     currentTableColName = currentData.sampleName;
%     currentTableRowName = currentData.subs;
%     set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
%         'ColumnName',currentTableColName,'RowName',currentTableRowName,...
%         'Enable','on');
% elseif currentData.whichTable == 2
%     currentTable = currentData.table;
%     currentTableColName = currentData.cond;
%     currentTableRowName = currentData.subs;
%     set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
%         'ColumnName',currentTableColName,'RowName',currentTableRowName,...
%         'Enable','on');
% elseif currentData.whichTable == 3
%     currentTable = (currentData.sample)';
%     currentTableColName = currentData.subs;
%     currentTableRowName = currentData.sampleName;
%     set(findobj(h2,'Tag','table_preview'),'Data',currentTable,...
%         'ColumnName',currentTableColName,'RowName',currentTableRowName,...
%         'Enable','on');
% elseif currentData.whichTable == 4
%     currentTable = (currentData.table)';
%     currentTableColName = currentData.subs;
%     currentTableRowName = currentData.cond;
%     set(findobj(h2,'Tag','table_preview'),'Data',currentTable,...
%         'ColumnName',currentTableColName,'RowName',currentTableRowName,...
%         'Enable','on');
% end
