function COVAIN_indexStat(obj,evt)
% receive user-defined seq

h = findobj('Tag','covainPanel_TOP');
dataStruct = guidata(h);
if dataStruct.loadNumber == 0
    return;
end
currentData = dataStruct.dataset(dataStruct.current).dataInfo;

tableData = currentData.table;

% judge if it is the checkbox or user's input
whichSeq = get(obj,'Tag');
if strcmp(whichSeq,'edit_indexStat')  % user's input
    if get(findobj(h,'Tag','checkbox_Stat'),'Value') == 1 % check checkbox state
        set(findobj(h,'Tag','checkbox_Stat'),'Value',0);
    end
    seq = str2num(get(obj,'String')); %#ok<ST2NM>
    if length(seq) < 2
        hErr1 = errordlg('At least two conditions!');
        uiwait(hErr1);
        uicontrol(obj);
    else
        if length(seq) > size(tableData,2) || max(seq)> size(tableData,2) ...
                || min(seq) < 0
            hErr2 = errordlg('Your input exceeds the length of the data!');
            uiwait(hErr2);
            uicontrol(obj);
        else
            tableDataNew = tableData(:,seq);
            currentData.dataStat = tableDataNew; % in use? yes, in corrStat
            currentData.condStat = currentData.cond(seq); % in use? yes.
            currentData.dataStat_OK = 1;
            % update guidata, but lagged in the data display
            dataStruct.dataset(dataStruct.current).dataInfo = currentData;
            guidata(h,dataStruct);
        end
    end
else     % check box 
    if get(obj,'Value') == 1
        set(findobj(h,'Tag','edit_indexStat'),'String',...
            'Input index, such as 1,2,3');
        currentData.dataStat = currentData.table; 
        currentData.condStat = currentData.cond;
        currentData.dataStat_OK = 1;
    else
        currentData.dataStat_OK = 0;
        currentData.dataStat = currentData.table; 
        currentData.condStat = currentData.cond;
    end
    % update guidata
    dataStruct.dataset(dataStruct.current).dataInfo = currentData;
    guidata(h,dataStruct);
end

