function COVAIN_indexTS(obj,evt)
%

h = findobj('Tag','covainPanel_TOP');
dataStruct = guidata(h);
if dataStruct.loadNumber == 0
    return;
end
currentData = dataStruct.dataset(dataStruct.current).dataInfo;

tableData = currentData.table;

% judge if it is the checkbox or user's input
whichSeq = get(obj,'Tag');
if strcmp(whichSeq,'edit_indexTS')  % user's input
    if get(findobj(h,'Tag','checkbox_TS'),'Value') == 1 % check checkbox state
        set(findobj(h,'Tag','checkbox_TS'),'Value',0)
    end
    seq = str2num(get(obj,'String')); %#ok<ST2NM>
    if length(seq) <= 3
        hErr1 = errordlg('The length of the time series must be larger than 3!');
        uiwait(hErr1);
        uicontrol(obj);
    else
        if length(seq) > size(tableData,2) || max(seq)> size(tableData,2) ...
                || min(seq) < 0
            hErr2 = errordlg('Your input exceeds the length of the data!');
            uiwait(hErr2);
            uicontrol(obj);
        else
            tableDataNew = tableData(:,seq);
            currentData.dataTS = tableDataNew;
            currentData.condTS = currentData.cond(seq);
            currentData.dataTS_OK = 1;
            % update guidata
            dataStruct.dataset(dataStruct.current).dataInfo = currentData;
            guidata(h,dataStruct);
        end
    end;
else  % check box
    if get(obj,'Value') == 1   % check input state
        set(findobj(h,'Tag','edit_indexTS'),'String','Input index, such as 4,2,3,1'); 
        currentData.dataTS = currentData.table;
        currentData.condTS = currentData.cond;
        currentData.dataTS_OK = 1;
    else
        currentData.dataTS_OK = 0;
    end
    % update guidata
    dataStruct.dataset(dataStruct.current).dataInfo = currentData;
    guidata(h,dataStruct);
end


