function COVAIN_missValueFill(obj,evt)
%
%
% Major revision @ 2012-01-24

h1 = get(obj,'Parent'); % hPanel_dataInfo
h2 = get(h1,'Parent');  % hMain

dataStruct = guidata(h2);
if dataStruct.loadNumber == 0
    return;
end
color_new = [1 0 1];
color_default = get(h2,'BackgroundColor');
currentData = dataStruct.dataset(dataStruct.current).dataInfo;
fillMethod = currentData.options.fillMissing;

dataOld    = currentData.oldData;
ind        = currentData.ind1;
ct         = currentData.count;
stateMiss  = currentData.stateMiss;
% rowIndex = 1:currentData.nRow;
% rowEmpty = [];

if stateMiss == 0
    if currentData.historyMiss == 0
        %msgbox('No missing data! Click OK to return.');
        return;
    else
        choice = questdlg('Are you sure to return to the original data?',...
            'Return to the original data?',...
            'No','Yes','No');
        if strcmp(choice,'Yes') == 1
            set(obj,'BackgroundColor',color_default);
            set(findobj(h2,'Tag','button_outlier'),'BackgroundColor',color_default);
            currentData.data = currentData.oldData;
            currentData.sample = currentData.data;
            currentData.snr = currentData.snrOld;
            currentData.table = currentData.tableOld;
            currentData.textMiss = currentData.textMissOld;
            currentData.textOut = currentData.textOutOld;
            currentData.stateMiss = ~currentData.stateMiss;
            currentData.stateOutlier = currentData.stateOutlierOld;
            currentData.whichTable = 2;
            
            % reset all buttons
            buttonAll = {'button_log';
                'button_Ztrans';
                'button_ZtransR';
                'button_miss';
                'button_normTrans';
                'button_outlier'};
            for i=1:length(buttonAll)
                set(findobj(h2,'Tag',buttonAll{i}),'BackgroundColor',color_default);
            end
            
            currentData.historyMiss = 0;
            currentData.historyOut = 0;
            currentData.historyLog = 0;
            currentData.historyZc = 0;
            currentData.historyZr = 0;
            currentData.history01 = 0;
            
            set(findobj(h2,'Tag','table_preview'),'Data',currentData.table,...
             'ColumnName',currentData.cond,'RowName',currentData.subs,...
             'Enable','on');
            set(findobj(h2,'Tag','radio_tableSelect_2'),'Value',1);
            set(findobj(h2,'Tag','text_miss'),'String',currentData.textMissOld,...
                'Enable','on');
            set(findobj(h2,'Tag','text_outlier'),'String',currentData.textOutOld,...
                'Enable','on');
                       
            dataStruct.dataset(dataStruct.current).dataInfo = currentData;
            guidata(h2,dataStruct);
        end
    end            
else
    dataNew = currentData.data;
    tmp1 = dataNew; tmp1 = tmp1(:); 
    minV_all = min(tmp1(tmp1(:)~=0));
    
% ======= The revised part ======
    
    if strcmp(fillMethod,'minimal') == 1
        for i=1:size(dataNew,1)
            if any(dataNew(i,:)~=0)
                dataNew(i,dataNew(i,:)==0) = .5*min(dataNew(i,dataNew(i,:)~=0));
            else
                dataNew(i,:) = repmat(.5*minV_all,1,size(dataNew(i,:),2));
            end
        end     
    
% ==========  The following are commented @ 2012.09.17 =========
%     if strcmp(fillMethod,'minimal') == 1
%         for i=1:size(dataNew,1)
%             for j=1:size(dataNew,2)
%                 if dataNew(i,j) == 0
%                     tmp2 = dataNew(i,:);
%                     if ~all(tmp2==0)
%                         minV = min(tmp2(tmp2~=0));
%                         %dataNew(i,j) = .5*minV*rand(1); % -----
%                         dataNew(i,j) = .5*minV;
%                     else
%                         minV = minV_all;
%                         %dataNew(i,j) = .5*minV*rand(1); % -----
%                         dataNew(i,j) = .5*minV;
%                     end
%                 end
%             end
%         end
% ==============================================================

    else
        for j=1:length(ind)
            dataBlock = dataOld(:,ind(j):ind(j)+ct(j)-1);
            % indexSolid = find(all(dataBlock~=0,2)>0);
            
            % % ratioS is outdated! 
            % ratioS = mean(std(dataBlock(indexSolid,:),[],2)./mean(dataBlock(indexSolid,:),2));
            
            dataNewBlock = dataBlock;
            for i=1:size(dataBlock,1)
                % -------  all the row are zeros --------
                if all(dataBlock(i,:)==0)
                    % rowEmpty = [rowEmpty,i];
                    % dataNewBlock(i,:) = rand(1,ct(j))*minV; 
                    minV = minV_all;
                    dataNewBlock(i,:) = rand(1,ct(j))*.5*minV; 
                    
                    % -------- only one non-zero entry -------
                    % Major change: fill with minimal values instead of
                    % prior distribution ! 
                elseif sum(dataBlock(i,:)~=0) == 1
                    minV = dataBlock(i,dataBlock(i,:)~=0);
                    dataNewBlock(i,dataBlock(i,:)==0) = rand(1,ct(j)-1)*.5*minV;
                    
% ==== The following codes are commented ====
%                     temp = dataBlock(i,:);
%                     dataBlock(i,:) = repmat(dataBlock(i,dataBlock(i,:)~=0),1,ct(j));
% 
%                     indexTemp = find(temp==0);
%                     ratioS1 = ratioS;
%                     for k=1:length(indexTemp)
%                         rr = randn(1);
%                         while dataBlock(i,indexTemp(k)) + ratioS1*rr*temp(temp~=0) < 0
%                             ratioS1 = 0.5*ratioS1;
%                         end
%                         dataNewBlock(i,indexTemp(k)) = dataBlock(i,indexTemp(k)) + ...
%                             ratioS1*rr*temp(temp~=0);
%                     end
%                     clear ratioS1 rr;
% ==== commented codes =====
                    
                    % ------- >= 2 non-zero entries -------
                else
                    std_i = std(dataBlock(i,dataBlock(i,:)~=0));
                    mean_i = mean(dataBlock(i,dataBlock(i,:)~=0));
                    indexB = find(dataBlock(i,:)==0);
                    std_i1 = std_i;
                    for k=1:length(indexB)
                        rr = randn(1);
                        while mean_i + std_i1*rr < 0
                            std_i1 = 0.5*std_i1;
                        end
                        dataNewBlock(i,indexB(k)) = mean_i + std_i1*rr;
                    end
                    clear std_i1;
                end
                
            end
            dataNew(:,ind(j):ind(j)+ct(j)-1) = dataNewBlock;
        end
    end
    
    % Highlight colors
    set(obj,'BackgroundColor',color_new);
   
    currentData.data = dataNew;
    currentData.stateMiss = ~currentData.stateMiss;
    
    tableData = currentData.table;
    snr = currentData.snr;
    for i=1:currentData.nRow
        for j=1:length(ct)
            tableData(i,j) = mean(dataNew(i,ind(j):ind(j)+ct(j)-1));
            snr(i,j) = tableData(i,j)/std(dataNew(i,ind(j):ind(j)+ct(j)-1));
        end
    end
    
    currentData.sample = dataNew;
    currentData.table = tableData;
    currentData.snr = snr;
    
    % update outlier values information
    flag_outlier = COVAIN_outlierValueReport(dataNew,ind,ct);
    if max(size(flag_outlier)) == 1
        outlierTotal = 0;
        outlierFlagState = 0;
    else
        outlierTotal = sum(sum(flag_outlier,2));
        outlierFlagState = 1;
    end
    
    text_dataOutlier = ['There are ',num2str(outlierTotal),' outlier values in  ',...
        num2str(currentData.nRow), ' substances'];
    currentData.textOut = text_dataOutlier;
    currentData.stateOutlier = outlierFlagState;
    currentData.matrixOutlier = flag_outlier;
    set(findobj(h2,'Tag','text_outlier'),'String',text_dataOutlier);
    
    % update missing value info
    strMiss =['There are 0 missing values in ',...
        num2str(currentData.nRow),' substances'];
    currentData.textMiss = strMiss;
    set(findobj(h2,'Tag','text_miss'),'String',strMiss);
    
    % update table preview
    hTop = h2;
    if currentData.whichTable == 1
        currentTable = currentData.sample;
        currentTableColName = currentData.sampleName;
        currentTableRowName = currentData.subs;
        set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
            'ColumnName',currentTableColName,'RowName',currentTableRowName,...
            'Enable','on');
    elseif currentData.whichTable == 2
        currentTable = currentData.table;
        currentTableColName = currentData.cond;
        currentTableRowName = currentData.subs;
        set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
            'ColumnName',currentTableColName,'RowName',currentTableRowName,...
            'Enable','on');
    elseif currentData.whichTable == 3
        currentTable = (currentData.sample)';
        currentTableColName = currentData.subs;
        currentTableRowName = currentData.sampleName;
        set(findobj(h2,'Tag','table_preview'),'Data',currentTable,...
            'ColumnName',currentTableColName,'RowName',currentTableRowName,...
            'Enable','on');
    elseif currentData.whichTable == 4
        currentTable = (currentData.table)';
        currentTableColName = currentData.subs;
        currentTableRowName = currentData.cond;
        set(findobj(h2,'Tag','table_preview'),'Data',currentTable,...
            'ColumnName',currentTableColName,'RowName',currentTableRowName,...
            'Enable','on');
    end
    
    % update process history
    currentData.historyMiss = 1;
    
    % update guidata
    dataStruct.dataset(dataStruct.current).dataInfo = currentData;
    guidata(h2,dataStruct);
end

% ****** nested function to identify outlier values *******
    function flag_outlier = COVAIN_outlierValueReport(dataOld,ind,ct)
        flag_outlier = zeros(size(dataOld,1),length(ind));
        for jOut = 1:length(ind)
            dataOldBlock = dataOld(:,ind(jOut):ind(jOut)+ct(jOut)-1);
            for iOut=1:size(dataOld,1)
                dataRow = dataOldBlock(iOut,:);
                mean_dataRow = mean(dataRow);
                std_dataRow = std(dataRow);
                indexOutlier = find(dataRow > mean_dataRow + ...
                    2*std_dataRow | dataRow < mean_dataRow -2*std_dataRow);
                flag_outlier(iOut,jOut) = ~isempty(indexOutlier);
            end
        end
        if all(flag_outlier(:)==0)
            flag_outlier = 0;
        end
    end

% ********************************************************
end

