function COVAIN_mzGetPaths(matFile,savePath)

% using parrel computing to accelerate calculation
% need to modify the local properties of parrell computing
% for Intel i-7 3770, 4 corse 8 threads, can set workers as 8
% tests on the example:
% tic;parfor i=1:length(mmNet)
% graphshortestpath(mmNetS,1,i);end;toc
% 8 workers: 5.6 seconds
% 6 workers: 6.3 s
% 4 workers: 7.1 s
% 2 workers: 11 s
% 1 worker:  16 s
% 
% Xiaoliang Sun @ 2014-01-23 ~ 2014-02-10
% make it full parallel @ 2014-06-19
% "in-situ" network visualization and modular analysis @ 2015-06-21

hTop = findobj('Tag','covainPanel_TOP');
A = load(matFile,'mmNet');         mmNet = A.mmNet;
A = load(matFile,'mmNetS');        mmNetS = A.mmNetS;
A = load(matFile,'data');          data = A.data;
A = load(matFile,'dataAll');       dataAll = A.dataAll;  
A = load(matFile,'mmNetPattern');  mmNetPattern = A.mmNetPattern;
A = load(matFile,'mzList');        mzList = A.mzList;
A = load(matFile,'mzName');        mzName = A.mzName;
A = load(matFile,'ruleList');      ruleList = A.ruleList; 
A = load(matFile,'compReal');      compReal = A.compReal; clear A;

len = length(mmNet); len2 = len*(len-1)/2;
allShortPath = cell(len*(len-1)/2,1); % upper tri matrix - diag

% get the indices
x = zeros(len*(len-1)/2,1); 
y = zeros(len*(len-1)/2,1); 
ct = 0;
for i=1:len
    for j=i+1:len                    % upper tri !!! always y > x !!!
        ct = ct + 1;
        x(ct) = i;  y(ct) = j;
    end
end

% % set four parallel jobs only if the user has parallel computing toolbox
toolboxList = arrayfun(@(x) x.Name, ver, 'UniformOutput',0);
parallelFlag = any(~cellfun(@isempty, regexp(toolboxList,'Parallel Computing Toolbox')));
if parallelFlag
    dataStruct = guidata(hTop);
    parVer = dataStruct.parVer;
    
    parfor i = 1:len2
        [~,allShortPath{i}] = graphshortestpath(mmNetS,x(i),y(i));
    end
    %matlabpool close;
else
    for i = 1:len2
        [~,allShortPath{i}] = graphshortestpath(mmNetS,x(i),y(i));
    end
end
% save allShortPath0 allShortPath;

% solid all paths
idxAll = 1:len2;
idxSolid = find(~cellfun(@isempty, allShortPath));
x_solid = x(idxSolid);
y_solid = y(idxSolid);
allSolidPath = allShortPath(idxSolid);

% filter out wrong time series
allTimedPath = cell(length(idxSolid),1); 
flgCorrect = zeros(length(idxSolid),1); 
for k = 1:length(idxSolid)
    pathArray = dataAll(allSolidPath{k},5); % cell array containing time series seq
    nRow = size(pathArray,1);
    if nRow == 1
        thePath = pathArray{1};
        continue;
    end
    i = 1; thePath = [];
    while i <= nRow - 1
        row1 = pathArray{i};
        row2 = pathArray{i+1};
        if min(row2) >= min(row1)  % continue to next loop
            thePath = [thePath, min(row1)];
            i = i + 1;
        elseif max(row2) < min(row1)
            thePath = -1;
            break;             % fails
        else
            nth = find(row2 >= min(row1), 1 ); % row2 values may not be consecutive
            pathArray{i+1} = pathArray{i+1}(nth:end);
            thePath = [thePath, min(row1)]; % continue, but remove smaller values in next row
            i = i + 1;
        end
    end
    if thePath ~= -1
        thePath = [thePath,min(pathArray{i})];
        allTimedPath{k} = thePath;
        flgCorrect(k) = 1;
    end
end
% update the indices
allTimedPath = allTimedPath(flgCorrect==1);
allCorrectPath = allSolidPath(flgCorrect==1);
idxCorrect = idxSolid(flgCorrect==1);
x_correct = x_solid(flgCorrect==1);
y_correct = y_solid(flgCorrect==1);
    
% elimate the correct paths
% if parallelFlag
%     matlabpool;
% end
fx = ones(length(x_correct),1);
fy = ones(length(y_correct),1);
siz = cellfun(@length, allCorrectPath);
ct = max(siz); 
while ct > 1
    idx = find(siz == ct);   tic; % decreasing from longest paths
    % make it parallel in the level of i
    if ~isempty(idx)              % ct may not be consecutive
        idxElim = cell(length(idx),1);
        parfor i=1:length(idx)
            s = allCorrectPath{idx(i)};
            groupS = nchoosek(s,2);     % find all intermediate paths
            groupS(groupS(:,1)==s(1) & groupS(:,2)==s(end),:) = []; % except this one
            % compare with allCorrectPath to judge if to elimate
            for j=1:size(groupS,1)
                node1 = min(groupS(j,:)); node2 = max(groupS(j,:));
                idxGlobal = find(x_correct == node1 & y_correct == node2);
                if fx(idxGlobal) & fy(idxGlobal)
                    if groupS(j,1) < groupS(j,2)  % remember the upper tri !!!
                        sPath = s(find(s==groupS(j,1)):find(s==groupS(j,2)));
                    else
                        sPath = s(find(s==groupS(j,2)):-1:find(s==groupS(j,1)));
                    end
                    % get the shortest path from original allCorrectPath
                    tPath = allCorrectPath{idxGlobal};
                    if length(tPath) == length(sPath) && all(tPath == sPath)
                        idxElim{i} = [idxElim{i}; idxGlobal];
                    end
                end 
            end
        end
        idxElimAll = [];
        for i=1:length(idx)
            idxElimAll = [idxElimAll; idxElim{i}];
        end
        fx(idxElimAll) = 0;  fy(idxElimAll) = 0;
    end
    ct = ct - 1;
    %disp([num2str(ct+1),' ...... ',num2str(toc),' ..... ',num2str(sum(fx))]); 
end

% save results
idxFinal = find(fx == 1);
finalCorrectPath = allCorrectPath(idxFinal);   
finalTimedPath = allTimedPath(idxFinal);
x_final = x_correct(idxFinal);
y_final = y_correct(idxFinal);
                   

% formulate allPath (all-in-one structure)
% columns: mzFrom/choFrom/mzTo/choTo/rules/dispPath/mzPath/choPath/TS
% % discarded: allPath = cell(length(finalCorrectPath),9);
str0.mzFrom = []; str0.choFrom = []; str0.mzTo =[]; str0.choTo = []; str0.rules = []; 
str0.rulePath = []; str0.dispPath = []; str0.mzPath = []; str0.choPath = []; str0.TS = []; 
allPath = repmat(str0,length(finalCorrectPath),1);
for i=1:length(allPath)
    s = finalCorrectPath{i};
    t = finalTimedPath{i};
    % mzFrom
    allPath(i).mzFrom = mzName{s(1)};
    % choFrom
    allPath(i).choFrom = dataAll{s(1),4};
    % mzTo
    allPath(i).mzTo = mzName{s(end)};
    % choTo
    allPath(i).choTo = dataAll{s(end),4};
    % rules
    ruleS = cell(1,length(s)-1);
    rulePath = zeros(1,length(s)-1);
    for j=1:length(s)-1
        ruleS{j} = ruleList{mmNetPattern(s(j),s(j+1))};
        rulePath(j) = mmNetPattern(s(j),s(j+1));
    end
    allPath(i).rules = ruleS;
    allPath(i).rulePath = rulePath;
    % dispPath
    dispPath = [];
    for j=1:length(s)-1
        dispPath = [dispPath, mzName{s(j)},' -> '];
    end
    dispPath = [dispPath,mzName{s(end)}];
    allPath(i).dispPath = dispPath;
    % mzPath
    allPath(i).mzPath = mzName(s)';
    % choPath
    allPath(i).choPath = dataAll(s,4)';
    % TS
    allPath(i).TS = t;
end

% construct the mz_dataStruct
mzStruct.data = data;
mzStruct.dataAll = dataAll;
mzStruct.finalCorrectPath = finalCorrectPath;
mzStruct.finalTimedPath = finalTimedPath;
mzStruct.mmNet = mmNet;
mzStruct.mmNetS = mmNetS;
mzStruct.mmNetPattern = mmNetPattern;
mzStruct.mzList = mzList;
mzStruct.mzName = mzName;
mzStruct.ruleList = ruleList;
mzStruct.x_final = x_final;
mzStruct.y_final = y_final;
mzStruct.allPath = allPath;
mzStruct.compReal = compReal;
correctFileName = matFile(regexp(matFile,'mzGroup_'):end-4);
save([savePath,correctFileName,'_mzStruct.mat'], 'mzStruct');

% ####################    END    ###################### 


% start mzPathViewer using internal data which is associated with 
% mzAnalyzer button, NOT with COVAIN main panel currentData !!!
set(findobj('Tag','button_mzGroup'),'UserData',mzStruct); 

% give loading path message to mzPathViewer and activate this button
pathStruct.dataType = 'internal';
pathStruct.dataPath = [savePath,correctFileName,'_mzStruct.mat'];
pathStruct.preSavePath = savePath; % in fact the "pathName" in mzAnalyzer
set(findobj('Tag','button_mzViewer'),'UserData',pathStruct);
COVAIN_mzPathViewer(findobj('Tag','button_mzViewer'));    




