function COVAIN_netFit(net)
% function COVAIN_netFit(net)

conn = sum(net); 
u = unique(conn); z = zeros(length(u),2);
for j=length(u):-1:1
    z(j,1) = u(j);
    z(j,2) = sum(conn==u(j))/length(conn);
end
semilogy(z(:,1),z(:,2),'bo','MarkerFaceColor','b'); hold on;

% plot(z(:,1),log10(z(:,2)),'bo','MarkerFaceColor','b'); hold on;
% yLim = get(gca,'YLim'); yMin = floor(min(yLim)); yMax = ceil(max(yLim));
% set(gca,'YTick',yMin:yMax, 'YTickLabel', 10.^(yMin:yMax));

xx = z(:,1); yy = z(:,2); % for curve fitting
xx(xx==0) = eps;
warning off;
if length(xx) >= 3   
    [f1,f2] = fit(xx,log10(yy),'poly1'); % 'weights',length(xx)+1-tiedrank(xx));
    plot(u,10.^(f1.p1*u+f1.p2),'r--','LineWidth',1.5); hold off;
    xlabel('Node degree'); ylabel('Fraction of nodes');
    legend('Node degree distribution',...
        ['Power law fitting (R^2 = ',num2str(f2.rsquare,'%2.2f'),')']);
    xLim = get(gca,'XLim'); stepA = ceil(range(xLim)/10); 
    set(gca,'XTick',floor(xLim(1)):stepA:ceil(xLim(2)));
    title('Power-law fitting','FontSize',11);
end
