function COVAIN_outlierValueFill(obj,evt)
%
%
h1 = get(obj,'Parent'); % hPanel_dataInfo
h2 = get(h1,'Parent');  % hMain

dataStruct = guidata(h2);
if dataStruct.loadNumber == 0
    return;
end
color_default = get(h2,'BackgroundColor');
color_new = [1 0 1];
currentData = dataStruct.dataset(dataStruct.current).dataInfo;

dataOld    = currentData.data;
ind        = currentData.ind1;
ct         = currentData.count;
stateMiss  = currentData.stateMiss;
stateOutlier = currentData.stateOutlier;


nRow = size(dataOld,1);

if stateOutlier == 0
    if currentData.historyOut == 0
        msgbox('No Outlier! Click OK to return.');
    else
        if stateMiss == 1
            warndlg('You must fill missing values first');
        else
            choice = questdlg('Are you sure to return to the original data?',...
                'Return to the original data?',...
                'No','Yes','No');
            if strcmp(choice,'Yes') == 1
                set(obj,'BackgroundColor',color_default);
                set(findobj(h2,'Tag','button_miss'),'BackgroundColor',color_default);
                currentData.data = currentData.oldData;
                currentData.sample = currentData.data;
                currentData.table = currentData.tableOld;
                currentData.textMiss = currentData.textMissOld;
                currentData.textOut = currentData.textOutOld;
                currentData.stateOutlier = ~currentData.stateOutlier;
                currentData.stateMiss = currentData.stateMissOld;
                currentData.whichTable = 2;
                
                % reset all buttons
                buttonAll = {'button_log';
                    'button_Ztrans';
                    'button_ZtransR';
                    'button_miss';
                    'button_normTrans';
                    'button_outlier'};
                for i=1:length(buttonAll)
                    set(findobj(h2,'Tag',buttonAll{i}),'BackgroundColor',color_default);
                end
                
                currentData.historyMiss = 0;
                currentData.historyOut = 0;
                currentData.historyLog = 0;
                currentData.historyZc = 0;
                currentData.historyZr = 0;
                currentData.history01 = 0;

                set(findobj(h2,'Tag','table_preview'),'Data',currentData.table,...
                 'ColumnName',currentData.cond,'RowName',currentData.subs,...
                 'Enable','on');
                set(findobj(h2,'Tag','radio_tableSelect_2'),'Value',1);
                set(findobj(h2,'Tag','text_miss'),'String',currentData.textMissOld,...
                    'Enable','on');
                set(findobj(h2,'Tag','text_outlier'),'String',currentData.textOutOld,...
                    'Enable','on');

                dataStruct.dataset(dataStruct.current).dataInfo = currentData;
                guidata(h2,dataStruct);
            end
        end
    end       
    
else
    if stateMiss == 1
        warndlg('You must fill missing values first');
    else
        dataNew = currentData.data;
        matrixOutlier = currentData.matrixOutlier;
        for j=1:length(ind)
            if all(matrixOutlier(:,j)==0)
                continue;
            else
                dataBlock = dataOld(:,ind(j):ind(j)+ct(j)-1);
                for i=1:nRow
                    dataRow = dataBlock(i,:);
                    muv = mean(dataRow);
                    stdv = std(dataRow);
                    indOut = find(dataRow > muv + 2*stdv | ...
                        dataRow < muv -2*stdv);
                    if isempty(indOut)
                        continue;
                    else
                        for iX = 1:length(indOut)
                            dataRow(indOut(iX)) = mean(dataRow(setdiff(1:ct(j),indOut)));
                        end
                        dataBlock(i,:) = dataRow;
                    end
                    
                end
                dataNew(:,ind(j):ind(j)+ct(j)-1) = dataBlock;
            end
        end
        currentData.data = dataNew;
        currentData.sample = currentData.data;
        currentData.stateOutlier = 0;
        % Highlight colors
        set(obj,'BackgroundColor',color_new);
        
        % update table values
        tableData = currentData.table;
        snr = currentData.snr;
        for i=1:currentData.nRow
            for j=1:length(ct)
                tableData(i,j) = mean(dataNew(i,ind(j):ind(j)+ct(j)-1));
                snr(i,j) = tableData(i,j)/std(dataNew(i,ind(j):ind(j)+ct(j)-1));
            end
        end
        currentData.table = tableData;
        currentData.snr = snr;
        
        
        % update text info
        strOutlier =['There are ',num2str(0),' outlier values in ',...
            num2str(currentData.nRow),' substances'];
        currentData.textOut = strOutlier;
        set(findobj(h2,'Tag','text_Outlier'),'String',strOutlier);
        set(findobj(h2,'Tag','table_preview'),'Data',dataNew);
        set(findobj(h2,'Tag','text_outlier'),'String',strOutlier);
        
        % update table preview
        hTop = h2;
        if currentData.whichTable == 1
            currentTable = currentData.sample;
            currentTableColName = currentData.sampleName;
            currentTableRowName = currentData.subs;
            set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
                'ColumnName',currentTableColName,'RowName',currentTableRowName,...
                'Enable','on');
        elseif currentData.whichTable == 2
            currentTable = currentData.table;
            currentTableColName = currentData.cond;
            currentTableRowName = currentData.subs;
            set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
                'ColumnName',currentTableColName,'RowName',currentTableRowName,...
                'Enable','on');
        elseif currentData.whichTable == 3
            currentTable = (currentData.sample)';
            currentTableColName = currentData.subs;
            currentTableRowName = currentData.sampleName;
            set(findobj(h2,'Tag','table_preview'),'Data',currentTable,...
                'ColumnName',currentTableColName,'RowName',currentTableRowName,...
                'Enable','on');
        elseif currentData.whichTable == 4
            currentTable = (currentData.table)';
            currentTableColName = currentData.subs;
            currentTableRowName = currentData.cond;
            set(findobj(h2,'Tag','table_preview'),'Data',currentTable,...
                'ColumnName',currentTableColName,'RowName',currentTableRowName,...
                'Enable','on');
        end
        
        % update process history
        currentData.historyOut = 1;
        
        % update guidata
        dataStruct.dataset(dataStruct.current).dataInfo = currentData;
        guidata(h2,dataStruct);
    end
end




