function COVAIN_preTrans(obj,evt)
%

h1 = get(obj,'Parent');  % hPanel_dataInfo
hTop = get(h1,'Parent'); % hPanel_Main

dataStruct = guidata(hTop);
if dataStruct.loadNumber == 0
    return;
end
currentData = dataStruct.dataset(dataStruct.current).dataInfo;
oldZ = currentData.oldData; 
color_default = get(findobj(hTop,'Tag','button_load'),'BackgroundColor');
color_new = [1 0 1];
options = currentData.options;

% reset data selection status in statistics % time series
set(findobj(hTop,'Tag','edit_indexStat'),'String','Input index, such as 1,2,3 ');
set(findobj(hTop,'Tag','edit_indexTS'),'String','Input index, such as 4,2,3,1 ');
set(findobj(hTop,'Tag','checkbox_Stat'),'Value',0);
set(findobj(hTop,'Tag','checkbox_TS'),'Value',0);
currentData.dataStat_OK = 0;
currentData.dataTS_OK = 0;

switch get(obj,'Tag')
    case 'button_log'
        % newly added .... need to fill missing values first
        if currentData.stateMiss == 1
            hWarn = warndlg('Please fill missing values first');
            uiwait(hWarn);
            return;
        end
        if currentData.historyLog == 1
            if strcmp(options.log,'Log10')==1
                currentData.data = 10.^currentData.data;
            else
                currentData.data = 2.^currentData.data;
            end
            currentData.data = real(currentData.data);
            currentData.sample = currentData.data;
            currentData.historyLog = 0;
            set(obj,'BackgroundColor',color_default);
        else
            if any(currentData.data(:)<0)
                choice = questdlg('Negative values found! Log transformation will produce complex numbers (such as 1 + 2i). Are you sure to proceed?',...
                    'Negative values warning',...
                    'Yes','No','No');
                if strcmp(choice,'Yes')==1
                    if strcmp(options.log,'Log10')==1
                        currentData.data = log10(currentData.data);
                    else
                        currentData.data = log2(currentData.data);
                    end
                    currentData.data = real(currentData.data);
                    currentData.sample = currentData.data;
                    currentData.historyLog = 1;
                    set(obj,'BackgroundColor',color_new);
                end
            elseif any(currentData.data(:)==0)
                warndlg('The data has missing values. Log transformation would produce NaN values, which may have problems in the further analysis.');
            else
                if strcmp(options.log,'Log10')==1
                    currentData.data = log10(currentData.data);
                else
                    currentData.data = log2(currentData.data);
                end
                currentData.data = real(currentData.data);
                currentData.sample = currentData.data;
                currentData.historyLog = 1;
                set(obj,'BackgroundColor',color_new);
            end
        end
        tableData = zeros(currentData.nRow,length(currentData.cond));
        snr = tableData;
        for i=1:size(tableData,1)
            for j=1:size(tableData,2)
                tableData(i,j) = mean(currentData.data(i,currentData.ind1(j):...
                    currentData.ind1(j) + currentData.count(j)-1));
                stdTemp = std(currentData.data(i,currentData.ind1(j):...
                    currentData.ind1(j) + currentData.count(j)-1));
                snr(i,j) = tableData(i,j)/stdTemp;
            end
        end
        tableData = real(tableData); 
        currentData.table = tableData; currentData.snr = snr;
        currentData.sample = currentData.data;
        dataStruct.dataset(dataStruct.current).dataInfo = currentData;
        guidata(hTop,dataStruct);
        
    case 'button_Ztrans'
%         % newly added .... need to fill missing values first
%         if currentData.stateMiss == 1
%             hWarn = warndlg('Please fill missing values first');
%             uiwait(hWarn);
%             return;
%         end
        
        if currentData.historyZc == 1
            currentData.historyZc = 0;
            if currentData.historyZr == 0
                currentData.data = currentData.oldZ;
            else
                currentData.data = oldZ;
                currentData.historyZc = 0;
                set(findobj(hTop,'Tag','button_ZtransR'),'BackgroundColor',color_default);
            end
            currentData.sample = currentData.data;
            tableData = zeros(currentData.nRow,length(currentData.cond));
            for i=1:size(tableData,1)
                for j=1:size(tableData,2)
                    tableData(i,j) = mean(currentData.data(i,currentData.ind1(j):...
                        currentData.ind1(j) + currentData.count(j)-1));
                end
             end
             currentData.table = tableData;
             set(obj,'BackgroundColor',color_default);
             currentData.whichTable = 2;
             set(findobj(hTop,'Tag','table_preview'),'Data',currentData.table,...
                'ColumnName',currentData.cond,'RowName',currentData.subs,...
                'Enable','on');
             set(findobj(hTop,'Tag','radio_tableSelect_2'),'Value',1);
             dataStruct.dataset(dataStruct.current).dataInfo = currentData;
             guidata(hTop,dataStruct);         
        else % update table data and data(sample)
            currentData.oldZ = currentData.data; 
            currentData.data = zscore(currentData.data,[],1);
            currentData.sample = currentData.data;
            tableData = zeros(currentData.nRow,length(currentData.cond));
            snr = tableData;
            for i=1:size(tableData,1)
                for j=1:size(tableData,2)
                    tableData(i,j) = mean(currentData.data(i,currentData.ind1(j):...
                        currentData.ind1(j) + currentData.count(j)-1));
                    stdTemp = std(currentData.data(i,currentData.ind1(j):...
                        currentData.ind1(j) + currentData.count(j)-1));
                    snr(i,j) = tableData(i,j)/stdTemp;
                end
            end
            tableData = real(tableData);
            currentData.table = tableData; currentData.snr = snr;
            currentData.historyZc = 1;
            dataStruct.dataset(dataStruct.current).dataInfo = currentData;
            guidata(hTop,dataStruct);
            set(obj,'BackgroundColor',color_new);
        end
    case 'button_ZtransR'
        if currentData.historyZr == 1
            currentData.historyZr = 0; % toggel switch
            if currentData.historyZc == 0
                currentData.data = currentData.oldZ;
            else
                currentData.data = oldZ;
                currentData.historyZr = 0;
                set(findobj(hTop,'Tag','button_Ztrans'),'BackgroundColor',color_default);
            end
            currentData.sample = currentData.data;
            tableData = zeros(currentData.nRow,length(currentData.cond));
            for i=1:size(tableData,1)
                for j=1:size(tableData,2)
                    tableData(i,j) = mean(currentData.data(i,currentData.ind1(j):...
                        currentData.ind1(j) + currentData.count(j)-1));
                end
             end
             currentData.table = tableData;
             set(obj,'BackgroundColor',color_default);
             currentData.whichTable = 2;
             set(findobj(hTop,'Tag','table_preview'),'Data',currentData.table,...
                'ColumnName',currentData.cond,'RowName',currentData.subs,...
                'Enable','on');
             set(findobj(hTop,'Tag','radio_tableSelect_2'),'Value',1);
             dataStruct.dataset(dataStruct.current).dataInfo = currentData;
             guidata(hTop,dataStruct);         
        else % update table data and data(sample)
            currentData.oldZ = currentData.data; 
            currentData.data = zscore(currentData.data,[],2);
            currentData.sample = currentData.data;
            tableData = zeros(currentData.nRow,length(currentData.cond));
            snr = tableData;
            for i=1:size(tableData,1)
                for j=1:size(tableData,2)
                    tableData(i,j) = mean(currentData.data(i,currentData.ind1(j):...
                        currentData.ind1(j) + currentData.count(j)-1));
                    stdTemp = std(currentData.data(i,currentData.ind1(j):...
                        currentData.ind1(j) + currentData.count(j)-1));
                    snr(i,j) = tableData(i,j)/stdTemp;
                end
            end
            tableData = real(tableData);
            currentData.table = tableData; currentData.snr = snr;
            currentData.historyZr = 1;
            dataStruct.dataset(dataStruct.current).dataInfo = currentData;
            guidata(hTop,dataStruct);
            set(obj,'BackgroundColor',color_new);
        end
        
    case 'button_normTrans' % 0-1 normalization
%         % newly added .... need to fill missing values first
%         if currentData.stateMiss == 1
%             hWarn = warndlg('Please fill missing values first');
%             uiwait(hWarn);
%             return;
%         end
        if currentData.history01 == 1
            currentData.history01 = 0;
            currentData.data = currentData.old01;
            currentData.sample = currentData.data;
            tableData = zeros(currentData.nRow,length(currentData.cond));
            for i=1:size(tableData,1)
                for j=1:size(tableData,2)
                    tableData(i,j) = mean(currentData.data(i,currentData.ind1(j):...
                        currentData.ind1(j) + currentData.count(j)-1));
                end
             end
             currentData.table = tableData;
             set(obj,'BackgroundColor',color_default);
             currentData.whichTable = 2;
             set(findobj(hTop,'Tag','table_preview'),'Data',currentData.table,...
                'ColumnName',currentData.cond,'RowName',currentData.subs,...
                'Enable','on');
             set(findobj(hTop,'Tag','radio_tableSelect_2'),'Value',1);
             dataStruct.dataset(dataStruct.current).dataInfo = currentData;
             guidata(hTop,dataStruct);         
        else % update table data and data(sample)            
            currentData.old01 = currentData.data;
            
            data0 = currentData.data; nrow = currentData.nRow;
            %data1 = detrend(data0,'constant')./repmat(max(data0)-min(data0),nrow,1);
            data1 = (data0 - repmat(min(data0),nrow,1))./repmat(max(data0)-min(data0),nrow,1);
            currentData.data = data1;
            
            currentData.sample = currentData.data;
            tableData = zeros(currentData.nRow,length(currentData.cond));
            snr = tableData;
            for i=1:size(tableData,1)
                for j=1:size(tableData,2)
                    tableData(i,j) = mean(currentData.data(i,currentData.ind1(j):...
                        currentData.ind1(j) + currentData.count(j)-1));
                    stdTemp = std(currentData.data(i,currentData.ind1(j):...
                        currentData.ind1(j) + currentData.count(j)-1));
                    snr(i,j) = tableData(i,j)/stdTemp;
                end
            end
            tableData = real(tableData);
            currentData.table = tableData; currentData.snr = snr;
            currentData.history01 = 1;
            dataStruct.dataset(dataStruct.current).dataInfo = currentData;
            guidata(hTop,dataStruct);
            set(obj,'BackgroundColor',color_new);
        end       
        
    case 'popup_norm'
        if (get(obj,'Value')) > 1 % internal standard and fresh weight
            if (get(obj,'Value')) == 2 
                hISpopFig = figure(...
                    'Interruptible','on',...
                    'Name','Internal standard selection',...
                    'NextPlot','new',...
                    'NumberTitle','off',...
                    'Resize','on',...
                    'MenuBar','none', ...
                    'Toolbar','none', ...
                    'Tag','ISpop',...
                    'HandleVisibility','callback');
                hPanel_ISpopFig = uipanel('Parent',hISpopFig,...
                    'Title',[],...
                    'Units','normalized',...
                    'Position',[0 0 1 1],...
                    'Tag','ISpop_panel');
                hButtonGroup_ISpopFig = uibuttongroup('Parent',hPanel_ISpopFig,...
                    'Title','Please select a compound for internal standard normalization',...
                    'FontSize',11,...
                    'FontWeight','bold',...
                    'Units','normalized',...
                    'Position',[.05 .15 .9 .75],...
                    'Tag','ISpop_Group',...
                    'SelectionChangeFcn',@buttonOK);
                hButton_ISok = uicontrol('Parent',hPanel_ISpopFig,...
                    'Style','pushbutton',...
                    'String','OK',...
                    'FontSize',10,...
                    'Units','normalized',...
                    'Position',[.4 .05 .2 .07],...
                    'Interruptible','off',...
                    'Tag','clusterFig_view',...
                    'CallBack',@buttonOK); 
                
                subsName = currentData.subs;
                hRadio_ISpopFig = zeros(1,length(subsName));
                for i=1:length(subsName)
                    flgSubs = any(currentData.data(i,:)==0);
                    if flgSubs == 1
                        enableState = 'off';
                    else
                        enableState = 'on';
                    end
                    hRaio_ISpopFig(i) = uicontrol('Parent',hButtonGroup_ISpopFig,...
                        'Style','radiobutton',...
                        'String',subsName{i},...
                        'FontSize',9,...
                        'Units','normalized',...
                        'Position',[.05+floor(i/15)*0.12 .85-.05*mod(i,15) .1 .05],...
                        'Tag',['radio_ISpopFig_subs',num2str(i)],...
                        'Value',~flgSubs,'Enable',enableState);
                end   
                
                % fresh weight
            else
                if currentData.freshOK == 1
                    % judge the validity of the fresh weight values
                    if any(currentData.freshValue <= 0)
                        hWarnX = warndlg('The fresh weight values contain zero or negative values. Do nothing.');
                        uiwait(hWarnX);
                    else
                        currentData.data = currentData.data ./ repmat(currentData.freshValue,currentData.nRow,1);
                        currentData.freshValue = ones(1,currentData.nCol); % avoid further division
                        %set(obj,'Foregroundcolor',[1 0 1]);
                        msgbox(' Done !');
                        currentData.historyFW = 1;
                    end
                else 
                    popName = currentData.sampleName; % use the same name
                    answer = cell(length(popName),1);
                    answerNum = ones(length(popName),1); % default value
                    flgFinish = 1;
                    if length(popName)>15
                        nWindow = ceil(length(popName)/15);
                    else
                        nWindow = 1;
                    end
                    for i=1:nWindow
                        if i ~= nWindow
                            a = inputdlg(popName((i-1)*15+1 : i*15));
                            if ~isempty(a)
                                answer((i-1)*15+1 : i*15) = a;
                            else
                                % answer((i-1)*15+1 : i*15) = repmat({'1'},15,1);
                                flgFinish = 0;
                                break; % jump out of the loop
                            end
                        else
                            a = inputdlg(popName((i-1)*15+1:end));
                            if ~isempty(a)
                                answer((i-1)*15+1:end) = a;
                            else
                                flgFinish = 0;
                                % answer((i-1)*15+1:end) = repmat({'1'},length(sampleName)-(i-1)*15,1);
                                break; % jump out of the loop
                            end
                        end
                    end
                    if flgFinish == 1
                        for i=1:length(answerNum)
                            if ~isempty(answer{i})  % need stronger validation ------
                                if isnumeric(str2double(answer{i}))==1
                                    if str2double(answer{i}) > 0
                                        answerNum(i) = str2double(answer{i});
                                    end
                                end
                            end
                            currentData.data(:,i) = answerNum(i)*currentData.data(:,i);
                        end
                    end
                end  % use default values or user's input
                
                
                % fresh weight data update
                tableData = zeros(currentData.nRow,length(currentData.cond));
                snr = tableData;
                for i=1:size(tableData,1)
                    for j=1:size(tableData,2)
                        tableData(i,j) = mean(currentData.data(i,currentData.ind1(j):...
                            currentData.ind1(j) + currentData.count(j)-1));
                        stdTemp = std(currentData.data(i,currentData.ind1(j):...
                            currentData.ind1(j) + currentData.count(j)-1));
                        snr(i,j) = tableData(i,j)/stdTemp;
                    end
                end
                tableData = real(tableData);
                currentData.table = tableData; currentData.snr = snr;
                currentData.sample = currentData.data;
                if flgFinish == 1
                    currentData.historyFW = 1; 
                    %set(obj,'Foregroundcolor',[1 0 1]);
                    msgbox(' Done !');
                end
                dataStruct.dataset(dataStruct.current).dataInfo = currentData;
                guidata(hTop,dataStruct);
            end  % fresh value or internal standard            
        end % fresh value and internal standard
        
end % all preTrans functions

% update table preview
if currentData.whichTable == 1
    currentTable = currentData.sample;
    currentTableColName = currentData.sampleName;
    currentTableRowName = currentData.subs;
    set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
        'ColumnName',currentTableColName,'RowName',currentTableRowName,...
        'Enable','on');
elseif currentData.whichTable == 2
    currentTable = currentData.table;
    currentTableColName = currentData.cond;
    currentTableRowName = currentData.subs;
    set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
        'ColumnName',currentTableColName,'RowName',currentTableRowName,...
        'Enable','on');
elseif currentData.whichTable == 3
    currentTable = (currentData.sample)';
    currentTableColName = currentData.subs;
    currentTableRowName = currentData.sampleName;
    set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
        'ColumnName',currentTableColName,'RowName',currentTableRowName,...
        'Enable','on');
elseif currentData.whichTable == 4
    currentTable = (currentData.table)';
    currentTableColName = currentData.subs;
    currentTableRowName = currentData.cond;
    set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
        'ColumnName',currentTableColName,'RowName',currentTableRowName,...
        'Enable','on');
end

% *********************************************************************
% ****  nested function to realize internal standard normalization ****
    function buttonOK(objS,evtS)
        newData = currentData.data;
        nRow1 = currentData.nRow;
        statusX = 0;
        for iRadio = 1:nRow1
            if get(hRaio_ISpopFig(iRadio),'Value') == 1
                newData = newData./repmat(newData(iRadio,:),nRow1,1);

                % internal standard normalization data update
                tableDataNew = zeros(currentData.nRow,length(currentData.cond));
                snrNew = tableDataNew;
                for iTab=1:size(tableDataNew,1)
                    for jTab=1:size(tableDataNew,2)
                        tableDataNew(iTab,jTab) = mean(newData(iTab,currentData.ind1(jTab):...
                            currentData.ind1(jTab) + currentData.count(jTab)-1));
                        stdTempNew = std(newData(iTab,currentData.ind1(jTab):...
                            currentData.ind1(jTab) + currentData.count(jTab)-1));
                        snrNew(iTab,jTab) = tableDataNew(iTab,jTab)/stdTempNew;
                    end
                end
                currentData.data = newData;
                currentData.table = tableDataNew; currentData.snr = snrNew;
                currentData.sample = newData;
                dataStruct.dataset(dataStruct.current).dataInfo = currentData;
                currentData.historyIS = 1;
                guidata(hTop,dataStruct);
                statusX = 1;
                break;
            end
        end
        if statusX == 1
            hDone = msgbox(' Done !');
            uiwait(hDone);
            delete(hISpopFig);
            %set(findobj(hTop,'Tag','popup_norm'),'ForegroundColor',[1 0 1]); 
            
            % update table preview
            if currentData.whichTable == 1
                currentTable = currentData.sample;
                currentTableColName = currentData.sampleName;
                currentTableRowName = currentData.subs;
                set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
                    'ColumnName',currentTableColName,'RowName',currentTableRowName,...
                    'Enable','on');
            elseif currentData.whichTable == 2
                currentTable = currentData.table;
                currentTableColName = currentData.cond;
                currentTableRowName = currentData.subs;
                set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
                    'ColumnName',currentTableColName,'RowName',currentTableRowName,...
                    'Enable','on');
            elseif currentData.whichTable == 3
                currentTable = (currentData.sample)';
                currentTableColName = currentData.subs;
                currentTableRowName = currentData.sampleName;
                set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
                    'ColumnName',currentTableColName,'RowName',currentTableRowName,...
                    'Enable','on');
            elseif currentData.whichTable == 4
                currentTable = (currentData.table)';
                currentTableColName = currentData.subs;
                currentTableRowName = currentData.cond;
                set(findobj(hTop,'Tag','table_preview'),'Data',currentTable,...
                    'ColumnName',currentTableColName,'RowName',currentTableRowName,...
                    'Enable','on');
            end
            
        end
    end
%  *********************************************************************

end




