function COVAIN_resetData(obj,evt)

h1 = get(obj,'Parent');  % hPanel_dataInfo
hTop = get(h1,'Parent'); % hPanel_Main
color_default = get(findobj(hTop,'Tag','button_load'),'BackgroundColor');

dataStruct = guidata(hTop);
if dataStruct.loadNumber == 0
    return;
end
currentData = dataStruct.dataset(dataStruct.current).dataInfo;
currentData.data = currentData.oldData; 
currentData.sample = currentData.data;
tableData = zeros(currentData.nRow,length(currentData.cond));
for i=1:size(tableData,1)
    for j=1:size(tableData,2)
        tableData(i,j) = mean(currentData.data(i,currentData.ind1(j):...
            currentData.ind1(j) + currentData.count(j)-1));
    end
end
currentData.table = tableData;
set(obj,'BackgroundColor',color_default);
currentData.whichTable = 2;
set(findobj(hTop,'Tag','table_preview'),'Data',currentData.table,...
    'ColumnName',currentData.cond,'RowName',currentData.subs,...
    'Enable','on');
set(findobj(hTop,'Tag','radio_tableSelect_2'),'Value',1);


% reset all buttons
buttonAll = {'button_log';
    'button_Ztrans';
    'button_ZtransR';
    'button_miss';
    'button_normTrans';
    'button_outlier'};
for i=1:length(buttonAll)
    set(findobj(hTop,'Tag',buttonAll{i}),'BackgroundColor',color_default);
end
 
%currentData.historyMiss = 0;
currentData.stateMiss = double(any(currentData.data(:)==0));
currentData.historyOut = 0;
currentData.historyLog = 0;
currentData.historyZc = 0;
currentData.historyZr = 0;
currentData.history01 = 0;

nMiss = sum(currentData.data(:)==0);
strMiss =['There are ', sprintf('%d',nMiss), ' missing values in ',...
        num2str(currentData.nRow),' substances'];
    currentData.textMiss = strMiss;
    set(findobj(hTop,'Tag','text_miss'),'String',strMiss);

dataStruct.dataset(dataStruct.current).dataInfo = currentData;
guidata(hTop,dataStruct);






